#ifndef __BUD_H__
#define __BUD_H__
/***************************************************************************
 *                                                                         *
 *   LB - The Little Budget Utility for GnuCash                            *
 *                                                                         *
 *   Copyright (C) 2004 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* bud.h
   Gabriel M. Beddingfield
   02OCT2004

   Object declaration for data when merging
   a GnuCash report with a "published"
   budget.

   Since it's a simple object, this is also
   the definition.
*/

#include <map>
#include <string>

using namespace std;

class bud {
  float           act_;
  float          plan_;
 public:
  bud(float a=0.0, float p=0.0) : act_(a), plan_(p)
    { }
  ~bud() { }

  int reset(void) {/* name_="";*/ act_=0.0; plan_=0.0; }
  float actual(void) { return act_; }
  float actual(const float v) { return act_ += v; }
  float planned(void) { return plan_; }
  float planned(const float v) { return plan_ += v; }
  float diff(void) { return plan_ - act_; }
  float diff(float k) { return k*plan_ - act_; }
};

typedef std::map<string, bud> accounts;

#endif // __BUD_H__
