/***************************************************************************
 *                                                                         *
 *   LB - The Little Budget Utility for GnuCash                            *
 *                                                                         *
 *   Copyright (C) 2004 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* budget.cpp
   Gabriel M. Beddingfield
   02OCT2004

   Class definition for ReadBudget object.
*/

#include "budget.h"
#define BUFFER 256

bool ReadBudget::more(void)
{
  static char buf[BUFFER];
  char* ptr;
  char delims[] = ",\n";

  if(!good()) { close(); return false; }
  if(eof()) { close(); return false; }

  // Skip over blank lines and comments
  getline(buf,BUFFER);
  while((buf[0]=='#')||(buf[0]=='\0')||isspace(buf[0])) {
    if(eof()) {
      close();
      return false;
    }
    getline(buf,BUFFER);
  }

  // Read in one record
  name_ = strtok(buf,delims);
  if(name_==NULL) {
    close();
    return false;
  }
  ptr = strtok(NULL,delims);
  if(ptr==NULL) {
    close();
    return false;
  }
  val_ = atof(ptr);

  return true;
}
